<template>
<div>
    <vue-dropzone @vdropzone-max-files-exceeded="maxFileExceeded" @vdropzone-complete="complete" ref="myVueDropzone" id="dropzone" :options="dropzoneOptions"></vue-dropzone>
</div>
</template>

<script>
let vm = null;
export default {
    data: function () {
        return {
            dropzoneOptions: {
                url: "https://httpbin.org/post",
                acceptedFiles: "image/*",
                thumbnailWidth: 150,
                maxFilesize: 10,
                maxFiles: 1,
                headers: {
                    "My-Awesome-Header": "header value",
                },
            },
        };
    },
    methods: {
        complete(response) {
            if (response) {
                const reader = new FileReader();
                let receivedFile;
                reader.readAsDataURL(response);
                reader.onload = function (event) {
                    receivedFile = event.target.result;
                    vm.$store.commit("image/UPDATE_TEMP_IMAGE", {
                        key: "org",
                        val: receivedFile,
                    });
                    let image = new Image();
                    image.src = receivedFile;
                    image.onload = function () {
                        vm.$store.commit("image/UPDATE_TEMP_IMAGE", {
                            key: "width",
                            val: this.width,
                        });
                        vm.$store.commit("image/UPDATE_TEMP_IMAGE", {
                            key: "height",
                            val: this.height,
                        });
                    };
                    vm.$refs.myVueDropzone.removeAllFiles();
                    vm.$store.commit("image/UPDATE_ACTIVE", 2);
                };
            }
        },
        maxFileExceeded(file) {
            this.$refs.myVueDropzone.removeFile(file);
        },
    },
    created() {
        vm = this;
    },
};
</script>

<style lang="scss">
#dropzone {
    position: relative;
    min-height: 200px;
    padding: 10px;

    .dz-preview {
        margin: 0;
        width: 100%;
    }

    .dz-message {
        position: absolute;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        margin: auto 0;
    }

    .dz-image img {
        max-width: 100%;
        height: auto;
        margin: 0 auto;
    }
}
</style>
